# -*- coding: utf-8 -*-
# Generated by Django 1.11.13 on 2018-06-15 17:24
from __future__ import unicode_literals
from builtins import str

import os
from django.db import migrations
from django.conf import settings

from bs4 import BeautifulSoup


def remove_brs(soup):
    for br in soup.findAll('br', recursive=False):
        br.decompose()


def remove_empty(soup):
    for element in soup.findAll(recursive=False):
        if not element.text.strip():
            element.decompose()


def cleanup(soup):
    remove_brs(soup)
    remove_empty(soup)


def convert_blog_images(apps, schema_editor):
    Entry = apps.get_model('blog', 'Entry')
    EntryContent = apps.get_model('blog', 'EntryContent')
    Image = apps.get_model('media', 'Image')

    # Loop through entries
    entries = Entry.objects.all()
    for entry in entries:
        # get text content
        content = (EntryContent.objects
                   .filter(entry=entry)
                   .exclude(text='')
                   .order_by('position', 'id'))
        if not content:
            continue

        # for through text content item, find images
        max_position = max([c.position for c in content])
        for item in content:
            soup = BeautifulSoup(item.text, 'html.parser')
            img_tags = soup.findAll('img')
            for img in img_tags:
                src = img.get('src', '')

                # Check if img src matches media library
                if not src.startswith(settings.MEDIA_URL):
                    continue

                uid, ext = os.path.splitext(os.path.basename(src))
                image = Image.objects.get(uid=uid)
                # make a new EntryContent
                new_item = EntryContent.objects.create(
                    entry=entry,
                    image=image,
                )
                max_position += 1
                EntryContent.objects.filter(id=new_item.id).update(position=max_position)

                # remove img tag
                img.decompose()

            if img_tags:
                cleanup(soup)
                item.text = str(soup)
                item.save()


class Migration(migrations.Migration):

    dependencies = [
        ('blog', '0001_initial'),
    ]

    operations = [
        migrations.RunPython(convert_blog_images, migrations.RunPython.noop),
    ]
